Subject: bug#28605: 26.0.60; Part of leftmost character hidden

From: Robert Pluim <[email-masked]>
Date: Fri, 06 Oct 2017 13:50:12 +0200

martin rudalics <[email-masked]> writes:

>> OK. The best course of action is then probably not to touch the
>> existing adjustments, and not to add any similar ones for the
>> horizontal case.
>
> Lars already touched them and IIUC provoked this bug.
>

Lars' HiDPI changes were a huge improvement over what was there
before. I'm talking here only about leaving alone the x_clear_area
code, but still changing the width calculation.

>>>> That code was added in commit c0055ff5b03c9121ab5bf752496b09416f0f0a7d
>>>> which is quite old,
>>>
>>> ... 2015 rather strikes me as "fairly recent" ...
>>>
>>
>> Oops, I think I looked at the date on the wrong commit, I thought I'd
>> seen 2010.
>
> OTOH this means that the code was not tested very intensively and Jan
> didn't have much time left to improve it.
>
>>>> I suspect it did no real harm even though oldx
>>>> tends to end up negative, possibly x_clear_area does some kind of
>>>> clipping.
>>>
>>> In my experience, X silently swallows anything that happens outside the
>>> frame.  GTK can be much more picky in this regard, especially when
>>> trying to draw something outside a parent widget.  But the corresponding
>>> error messages are usually a pain to read.
>>
>> Yet another reason not to disturb the status quo.
>
> To be on the safe side, we probably should leave the non-scaling parts
> alone.  For the scaling parts do whatever you consider appropriate.  If
> it fixes the behavior for Ola, we should install it and wait for
> complaints.

OK, I'll wait for Ola confirm, then clean it up (and split it into at
least 2 to make it easier to revert).

Robert